#include <netinet/in.h> 
#define __USE_BSD
#include <netinet/ip.h> 
#include <netinet/ip_icmp.h> 
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <cstdio>
#include <iostream>

using namespace std;

unsigned short
csum (unsigned short *buf, int nwords)
{
    unsigned long sum;
    for (sum = 0; nwords > 0; nwords--)
        sum += *buf++;
    sum = (sum >> 16) + (sum & 0xffff);
    sum += (sum >> 16);
    return ~sum;
}

struct header
{
    struct ip iph;
    struct icmphdr icmph;
};

int
main ()
{
    int sockfd = socket (AF_INET, SOCK_RAW, IPPROTO_ICMP);

    struct sockaddr_in dst, src;
    dst.sin_addr.s_addr = inet_addr ("212.191.76.4");
    dst.sin_port = 0;
    dst.sin_family = AF_INET;


    struct header ipicmp;

    ipicmp.iph.ip_hl = 5;
    ipicmp.iph.ip_v = 4;
    ipicmp.iph.ip_p = IPPROTO_ICMP;
    ipicmp.iph.ip_tos = 0;
    ipicmp.iph.ip_len = sizeof (struct header);
    ipicmp.iph.ip_id = 0;
    ipicmp.iph.ip_off = htons (IP_DF);
    ipicmp.iph.ip_ttl = 255;
    ipicmp.iph.ip_sum = 0;
    ipicmp.iph.ip_src.s_addr = INADDR_ANY;
    ipicmp.iph.ip_dst.s_addr = dst.sin_addr.s_addr;

    ipicmp.icmph.type = ICMP_ECHO;
    ipicmp.icmph.code = 0;
    ipicmp.icmph.checksum = 0;
    ipicmp.icmph.checksum = csum ((unsigned short *) &ipicmp.icmph, 
            sizeof (ipicmp.icmph) >> 1);

    ipicmp.iph.ip_sum = csum ((unsigned short *) &ipicmp.iph,
            sizeof (ipicmp) >> 1);

    {				/* lets do it the ugly way.. */
        int one = 1;
        const int *val = &one;
        if (setsockopt (sockfd, IPPROTO_IP, IP_HDRINCL, 
                    val, sizeof (one)) < 0)
            perror ("Warning: Cannot set HDRINCL!");
    }

    if (sendto (sockfd, &ipicmp, sizeof (ipicmp), 0, 
                (struct sockaddr *) &dst, sizeof (struct sockaddr)) < 0)
        perror ("funkcja sendto");
    
    struct header buf;
    socklen_t len = sizeof (struct sockaddr);

    if (recvfrom (sockfd, &buf, sizeof (buf), 0,
                (struct sockaddr *) &src, &len) < 0)
        perror ("funkcja recvfrom");

/*    if (recvfrom (sockfd, &buf, sizeof (buf), 0,
                (struct sockaddr *) &src, &len) < 0)
        perror ("funkcja recvfrom");
*/

    cout << "Adres: " << inet_ntoa (buf.iph.ip_src) << endl;

    cout << "Typ: " << (unsigned int) buf.icmph.type << endl;
    if (buf.icmph.type == ICMP_ECHOREPLY)
        std::cout << "Komputer zyje!" << endl;
    else 
        std::cout << "Komputer nie zyje!" << endl;

    return 0;
}
